//
// Created by Attila Haluska on 8/1/18.
//

#ifndef ASPL_C_LEXER_H
#define ASPL_C_LEXER_H

#include <stdbool.h>
#include <stdint.h>

#include "forward_declarations.h"

typedef struct lexer_t {
    const char* token_start;
    const char* current_position;
    const char* current_line_start;
    uint64_t line;
} Lexer;

extern void lexer_init(Lexer* lexer, const char* source);
extern void lexer_free(Lexer* lexer);
extern Token* lexer_next_token(Lexer* lexer);

#endif //ASPL_C_LEXER_H
