//
// Created by Attila Haluska on 8/2/18.
//

#ifndef ASPL_C_FORWARD_DECLARATIONS_H
#define ASPL_C_FORWARD_DECLARATIONS_H

#include <stdbool.h>

// token.h
typedef enum token_type_t TokenType;
typedef struct token_t Token;

// lexer.h
typedef struct lexer_t Lexer;

// ast_node.h
typedef struct ast_node_t AstNode;

// precedence.h
typedef enum precedence_t Precedence;

// uint8_array.h
typedef struct uint8_array_t Uint8Array;

// uint64_array.h
typedef struct uint64_array_t Uint64Array;

// bytecode_array.h
typedef struct bytecode_array_t BytecodeArray;

// vm_opcode.h
typedef enum opcode_t Opcode;

// value.h
typedef enum value_type_t ValueType;
typedef struct value_t Value;

// vm.h
typedef enum vm_interpret_result_t VmInterpretResult;
typedef struct vm_t Vm;

// vm_functions.h
typedef enum vm_binary_operation_t VmBinaryOperation;

// vm_opcode_functions.h
typedef void (* VmOpcodeFunction)(Vm* vm, bool* shouldReturn, VmInterpretResult* result);

#endif //ASPL_C_FORWARD_DECLARATIONS_H
