//
// Created by Attila Haluska on 9/7/18.
//

#include "vm/value.h"

#include <stdio.h>

#include "memory_management/memory.h"

Value* value_new_double_value(long double value) {
    Value* v = NEW(Value);

    v->type = VAL_DOUBLE;
    v->as.double_value = value;

    return v;
}

Value* value_new_integer_value(int64_t value) {
    Value* v = NEW(Value);

    v->type = VAL_INTEGER;
    v->as.integer_value = value;

    return v;
}

void value_delete(Value* value) {
    if (value != NULL) {
        DELETE_TYPE(Value, value);
    }
}

void value_print(const Value* value) {
    switch (value->type) {
        case VAL_INTEGER:
            fprintf(stdout, "%lld", AS_INTEGER(value));
            break;
        case VAL_DOUBLE:
            fprintf(stdout, "%Lf", AS_DOUBLE(value));
            break;
        default:
            fprintf(stdout, "unknown");
            break;
    }
}
