//
// Created by Attila Haluska on 9/7/18.
//

#ifndef ASPL_C_VALUE_H
#define ASPL_C_VALUE_H

#include <stdint.h>

#define IS_DOUBLE(value)    (value)->type == VAL_DOUBLE
#define IS_INTEGER(value)   (value)->type == VAL_INTEGER
#define IS_NUMBER(value)    (IS_DOUBLE(value) || IS_INTEGER(value))

#define AS_DOUBLE(value)    (value)->as.double_value
#define AS_INTEGER(value)   (value)->as.integer_value

typedef enum value_type_t {
    VAL_DOUBLE,
    VAL_INTEGER,
} ValueType;

typedef struct value_t {
    ValueType type;
    union {
        long double double_value;
        int64_t integer_value;
    } as;
} Value;

extern Value* value_new_double_value(long double value);
extern Value* value_new_integer_value(int64_t value);
extern void value_delete(Value* value);
extern void value_print(const Value* value);

#endif //ASPL_C_VALUE_H
