//
// Created by Attila Haluska on 9/8/18.
//

#ifndef ASPL_C_VM_H
#define ASPL_C_VM_H

#include "data_structures/bytecode_array.h"

#define STACK_MAX   (256)

typedef enum vm_interpret_result_t {
    VM_INTERPRET_OK = 0,
    VM_INTERPRET_COMPILE_ERROR,
    VM_INTERPRET_RUNTIME_ERROR,
} VmInterpretResult;

typedef struct vm_t {
    BytecodeArray code;
    uint8_t* ip;
    Value* stack[STACK_MAX];
    Value** stack_top;
} Vm;

extern void vm_init(Vm* vm);
extern void vm_free(Vm* vm);
extern VmInterpretResult vm_interpret(Vm* vm, const char* source);

#endif //ASPL_C_VM_H
