//
// Created by Attila Haluska on 9/8/18.
//

#ifndef ASPL_C_VM_FUNCTIONS_H
#define ASPL_C_VM_FUNCTIONS_H

#include <stdint.h>
#include <stdbool.h>

#include "forward_declarations.h"

typedef enum vm_binary_operation_t {
    VM_BIN_OP_ADD,
    VM_BIN_OP_SUBTRACT,
    VM_BIN_OP_MULTIPLY,
    VM_BIN_OP_DIVIDE,
} VmBinaryOperation;

extern uint8_t vm_read_byte(Vm* vm);
extern Value* vm_read_constant(Vm* vm);

extern void vm_push(Vm* vm, Value* value);
extern Value* vm_pop(Vm* vm);
extern Value* vm_peek(Vm* vm, uint8_t distance);

extern void vm_reset_stack(Vm* vm);
extern void vm_runtime_error(Vm* vm, const char* format, ...);

extern void vm_binary_operation(Vm* vm, VmBinaryOperation operation, bool* should_return, VmInterpretResult* result);

#endif //ASPL_C_VM_FUNCTIONS_H
